package com.example.pibd22_kalyshev_y_v_motorboat_hard;

import javafx.scene.canvas.GraphicsContext;
import javafx.scene.paint.Color;

public class DrawningSpeedboat extends DrawningBoat
{
    public DrawningSpeedboat(int speed, float weight, Color bodyColor, Color dopColor, boolean bodyKit, boolean wing, boolean sportLine)
    {
        super(speed, weight, bodyColor, 195, 80);
        SetBoat(new EntitySpeedboat(speed, weight, bodyColor, dopColor, bodyKit, wing, sportLine));
    }
    @Override
    public void DrawTransport(GraphicsContext gc)
    {
        if (!(GetBoat() instanceof EntitySpeedboat speedboat))
        {
            return;
        }

        _startPosX += 8;
        _startPosY += 1;
        super.DrawTransport(gc);
        _startPosX -= 8;
        _startPosY -= 1;

        gc.setStroke(Color.BLACK);
        gc.setLineWidth(2);

        if (speedboat.GetBodyKit())
        {
            double[] turretX =
                    {
                            31.0 + _startPosX,
                            31.0 + _startPosX,
                            45.0 + _startPosX,
                            83.0 + _startPosX,
                            97.0 + _startPosX,
                            97.0 + _startPosX,
                    };

            double[] turretY =
                    {
                            24.0 + _startPosY,
                            12.0 + _startPosY,
                            2.0 + _startPosY,
                            2.0 + _startPosY,
                            12.0 + _startPosY,
                            24.0 + _startPosY,
                    };

            gc.setFill(speedboat.GetDopColor());
            gc.fillPolygon(turretX, turretY, 6);
            gc.strokePolygon(turretX, turretY, 6);
            gc.strokeRect(32 + _startPosX, 22 + _startPosY, 64, 2);

            double[] muzzleX =
                    {
                            94 + _startPosX,
                            84 + _startPosX,
                            120 + _startPosX,
                            120 + _startPosX,
                    };

            double[] muzzleY =
                    {
                            9 + _startPosY,
                            3 + _startPosY,
                            3 + _startPosY,
                            9 + _startPosY,
                    };

            gc.setFill(Color.rgb(109, 137, 165));
            gc.fillPolygon(muzzleX, muzzleY, 4);
            gc.strokePolygon(muzzleX, muzzleY, 4);
            gc.fillRect(120 + _startPosX, 2 + _startPosY, 16, 8);
            gc.strokeRect(120 + _startPosX, 2 + _startPosY, 16, 8);
        }

        if (speedboat.GetWing())
        {
            gc.moveTo(60 + _startPosX, 1 + _startPosY);
            gc.lineTo(60 + _startPosX, 24 + _startPosY);
            gc.closePath();

            gc.setFill(speedboat.GetDopColor());
            gc.fillRect(_startPosX, 2 + _startPosY, 58, 8);
            gc.strokeRect(_startPosX, 2 + _startPosY, 58, 8);
            gc.fillRect(_startPosX, 10 + _startPosY, 58, 8);
            gc.strokeRect(_startPosX, 10 + _startPosY, 58, 8);
            gc.fillRect(_startPosX, _startPosY, 6, 17);
            gc.strokeRect(_startPosX, _startPosY, 6, 17);

            double[] batteryMoutX =
                    {
                            24 + _startPosX,
                            15 + _startPosX,
                            58 + _startPosX,
                            58 + _startPosX
                    };
            double[] batteryMoutY =
                    {
                            24 + _startPosY,
                            18 + _startPosY,
                            18 + _startPosY,
                            24 + _startPosY
                    };
            gc.setFill(Color.rgb(21, 39, 71));
            gc.fillPolygon(batteryMoutX, batteryMoutY, 4);
            gc.strokePolygon(batteryMoutX, batteryMoutY, 4);
        }
    }
}